/*
 hmp.c, Hubris Module Player. Copyright (C) 1997 by Chem of Hubris.
 see 'hmpdoc.txt' for info.

 remember to link hub_mp.a and mix.o!
*/
#include "hub_mp.h" /* player, devices and loaders */

void main(int paramcount,char *paramstr[]) /* ah, the good old pascal way :) */
{
 int initi/*,sfx_handle*/;
 char *command_com=getenv("COMSPEC"); /* get the command.com name */

 memset(error,0,sizeof(error)); /* clear the error string */

 if (paramcount<2) /* no module name given */
  {
   strcat(error,"usage: hmp.exe [path]module[.MOD/.S3M] [setup] \n");
   lopeta(1);
  }

 if ( (paramcount>2) && (strncasecmp("setup",paramstr[2],5)==0) ) initi=1;
  else initi=0;

 /* initialize the sound device */
 if (init_device(initi)==-1)
  {
   strcat(error,"could not initialize the sound device.\n");
   lopeta(1);
  }

 module.file_offset=0; /* load the module from file offset 0 */
 module.sample_space=0;
 if ( __load_MOD_or_S3M(paramstr[1])!=0 )  /* do the loading */
  {
   deinit_device();
   lopeta(1); /* halt on error */
  }

 __init_sam_engine();
 __init_sfx_engine(0); /* number of sfx channels */
 /* these channels are counted in set_channels */

 /* at this point, load all samples */
/* _output_loadsample_signed_8_bits_raw("bbcnews.raw",(sfx_handle=__get_smp_nro()),
                                      22050,128,0,0);*/

 /* set a proper amount of active channels */
 _output_set_channels(module.channels); /*only the module channels!*/

 /* start playing (module) */
 init_playing();

 /* play a sample using the handle given at load time */             
/* _output.playsample(__get_sfx_chan(),sfx_handle,64,-1,-1,0);*/

 /* shell to dos */
 if (command_com!=NULL) system(command_com);
  else system("command.com");

 while (kbhit()) getch(); /* flush input */
 while (!kbhit())
  {
   printf("pat: %d, order: %d, row: %d, speed: %d, bpm: %d  \r",
           play.physpatta,play.order,play.row,play.speed,play.bpm);
  }
 while (kbhit()) getch(); /* flush input */
 printf("\n");

 /* stop playing */
 deinit_playing();

 /* release module */
 free_mod();

 /* deinitialize the output device */
 deinit_device();

 /* add usage to the error list */
 strcat(error,"usage: hmp.exe [path]module[.MOD/.S3M] [setup] \n");

 /*display non-exit-the-program-immediately error messages+usage and exit*/
 lopeta(0);
}
/* end of modplay2.c */
